﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Com.Rscja.Deviceapi.Entity;

namespace DemoM1
{
	[Activity (Label = "Ulartlight")]			
	public class Ulartlight : Activity
	{
		ArrayAdapter adapterulblock;
		Button btnreadul;
		Button btnwriteul;
		EditText txtdata;
		Spinner spblockul;
		TextView labmsg;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);
			SetContentView (Resource.Layout.ultralight);
			// Create your application here

			InitView ();
		}

		void InitView()
		{
			btnreadul = FindViewById<Button> (Resource.Id.btnreadul);
			btnwriteul = FindViewById<Button> (Resource.Id.btnwriteul);
			txtdata = FindViewById<EditText> (Resource.Id.editdataul);
			spblockul = FindViewById<Spinner> (Resource.Id.spblockul);
			labmsg = FindViewById<TextView> (Resource.Id.labmsgul);


			adapterulblock = ArrayAdapter.CreateFromResource(this,Resource.Array.arraySectorUL, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			adapterulblock.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spblockul.Adapter = adapterulblock;
			spblockul.SetSelection (0);

			btnreadul.Click += new EventHandler (delegate {
				labmsg.Text=readul ();
			});

			btnwriteul.Click += new EventHandler (delegate {
				if(string.IsNullOrEmpty(txtdata.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputdata, ToastLength.Long).Show();
					return;
				}
				if(txtdata.Text.Length!=8)
				{
					Toast.MakeText(this, Resource.String.msgulinputlen, ToastLength.Long).Show();
					return;
				}
				if(!PubClass.isHexNumberRex(txtdata.Text))
				{
					Toast.MakeText(this, Resource.String.msgm1inputkeyhex, ToastLength.Long).Show();
					return;
				}
				labmsg.Text=writeul (txtdata.Text);
			});
		}

		string readul()
		{
			SimpleRFIDEntity rf = null;	
			string msg = "";
			rf=PubClass.rfid.Request ();
			if (rf != null) {
				msg =  rf.Id+"\r\n";
				try{
					rf=PubClass.rfid.Read (spblockul.SelectedItemPosition);
					return msg+rf.Data;
				} catch (Exception e) {
					// TODO Auto-generated catch block
					//e.printStackTrace();
					//Log.i("密码验证失败", e.getMessage());
					return msg + GetString (Resource.String.msgm1readexp);
				}

			} else {
				return  GetString (Resource.String.msgm1getcardno);
			}
		}
	
	
		string writeul(string data)
		{
		
			SimpleRFIDEntity rf = null;	
			string msg = "";
			rf=PubClass.rfid.Request ();
			if (rf != null) {
				msg =  rf.Id+"\r\n";
				try{
					Boolean re=PubClass.rfid.Write(spblockul.SelectedItemPosition,data);
					if (re) {
						msg +=  GetString (Resource.String.msgm1writesucc);
						return msg;
					} else
						return  msg+ GetString (Resource.String.msgm1writefial);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					//e.printStackTrace();
					//Log.i("密码验证失败", e.getMessage());
					return msg+ GetString (Resource.String.msgm1readexp);
				} 

			} else {
				return  GetString (Resource.String.msgm1getcardno);
			}
		}


	}
}

